using System;
using System.Text;
using System.Runtime.InteropServices;

// This should be compiled as a C# console program; ConsoleLib will try to grab the handles for an existing console

// A great thanks to Ben Ryves for his great C++/Win32 console tutorial

namespace TestClass
{
	public class ConsoleLib
	{
		//this is just a test program to show how to use it
		public static void Main(string[] args)
		{
			// initialize the console; if you want to change the window buffer size later, 
			// please call QuitConsole first and call InitConsole after.
			InitConsole("CS/ConsoleLib Window", 80, 50);

			//set up the fps counter
			int t0 = Environment.TickCount;
			int frames = 0;

			while (isRunning)
			{
				//test whether we want to quit; this could be wrapped into a function
				if ((GetAsyncKeyState((int)Keys.Up) & 0x8000) != 0)
					isRunning = false;
				
				//write to the screen
				for (int x = 0; x < 80; x++)
					for (int y = 0; y < 50; y++)
						SetCC(x, y, (byte)rand.Next(255), (byte)rand.Next(255));
				//commit the changes and actually update the console
				UpdateConsole();
				frames++;
			}
			//calculate and show fps; it also shows how C# and C++ console methods can get along
			t0 = Environment.TickCount - t0;
			frames = frames * 1000 / t0;
			Console.SetCursorPosition(0, 0);
			Console.ForegroundColor = ConsoleColor.White;
			Console.BackgroundColor = ConsoleColor.Black;
			Console.WriteLine(frames.ToString());
			Console.ReadLine();

			QuitConsole();
		}

		public static Random rand = new Random();
		public static bool isRunning = true;

		[DllImport("ConsoleLib.dll")]
		public static extern void InitConsole(string title, int width, int height);
		[DllImport("ConsoleLib.dll")]
		public static extern void SetCC(int x, int y, byte ch, byte col);
		[DllImport("ConsoleLib.dll")]
		public static extern void SetChar(int x, int y, byte c);
		[DllImport("ConsoleLib.dll")]
		public static extern void SetColor(int x, int y, byte color);
		[DllImport("ConsoleLib.dll")]
		public static extern byte GetChar(int x, int y);
		[DllImport("ConsoleLib.dll")]
		public static extern byte GetColor(int x, int y);
		[DllImport("ConsoleLib.dll")]
		public static extern void UpdateConsole();
		[DllImport("ConsoleLib.dll")]
		public static extern void ForceUpdate();
		[DllImport("ConsoleLib.dll")]
		public static extern void WriteGarbage();
		[DllImport("ConsoleLib.dll")]
		public static extern void QuitConsole();
		[DllImport("User32.dll")]
		public static extern short GetAsyncKeyState(int keyCode);

		public enum Keys
		{
			Left = 37,
			Up = 38,
			Right = 39,
			Down = 40
		}
	}
}
